!+
!KWIC switch.h
!
!Id$
!
!History:
!   1996-Jun-05[T. Gaetz]
!      . moved from individual source files to included file.
!      . reordered:  double precision, real, integer.
!      . add save statement
!
!  DEFINITIONS (extracted from source files):
!
!  /SWITCH/ VARIABLES INITIALIZED, ALL ARE LOGICAL * 1:
!    GENERAL SYSTEM SWITCHES:
!    LSW0 (1) : NOT USED (FORMERLY X-RAY SYSTEM SWITCH)
!    LSW0 (2) : NOT USED
!    LSW0 (3) : F - ZOFF WRT GFOC, T - ZOFF WRT STD
!  FOLLOWING SWITCH ADDED FOR POLARIZATION
!    LSW0 (4) : F - RANDOM POLARIZATION, T - DISCRETE POLARIZATION
!    LSW0 (5 TO 10) : NOT USED
!    SWITCHES FOR SURFACE J:
!    LSW (1, J) : F - CONCAVE SURFACE, T - CONVEX SURFACE
!    LSW (2, J) : F - NO SURFACE DEFORMATIONS, T - SURFACE DEFORMATIONS
!    LSW (3, J) : F - NOT FLAT, T - FLAT
!    LSW (4, J) : F - ON AXIS, T - OFF AXIS
!  FOLLOWING THREE SWITCHES ADDED FOR OBSCURATION-TYPE SURFACES
!    LSW (5, J) : F - NOT AN ANNULAR OBSCURATION, T - ANNULAR OBSC
!    LSW (6, J) : F - NOT A RECTANGULAR OBSC, T - RECTANGULAR OBSC
!    LSW (7, J) : F - "OBSC" IS AN OPENING, T - "OBSC" IS OPAQUE
!  FOLLOWING SWITCH ADDED FOR TOROIDAL SURFACE
!    LSW (8, J) : F - NOT TOROIDAL, T - TOROIDAL
!  FOLLOWING SWITCH ADDED FOR X-RAY SURFACE
!    LSW (9, J) : F - CONVENTIONAL, T - X-RAY
!    LSW (10, J) : NOT USED

      LOGICAL * 1     LSW0,      LSW
      COMMON /SWITCH/ LSW0 (10), LSW (10, 21)
      SAVE   /SWITCH/
